#ifndef SOLVER_HPP
#define SOLVER_HPP

#include <iostream>
#include <vector>

#include "diagonals.hpp"
#include "dllist.hpp"
#include "farray.hpp"
#include "fstack.hpp"

unsigned int solve(
  std::ostream& stream,
  const FArray<FArray<__uint128_t>>& diagonals);

void solve(
  std::ostream& stream,
  const FArray<FArray<__uint128_t>>& diagonals,
  const FArray<FArray<unsigned int>>& availableCells,
  FArray<FStack<__uint128_t>>& partial);

std::ostream& operator<<(std::ostream& stream, const FStack<__uint128_t>& list);

#endif  // SOLVER_HPP
