#include "clparser.hpp"

bool parseArgs(int argc, char** argv, argmap& parsed) {
  parsed.clear();

  for (int numArgs = 1; numArgs < argc; numArgs++) {
    if (argv[numArgs][0] == '-') {
      if (argv[numArgs][1] == 'h') {
        parsed.insert({"-h", ""});
      } else if (argv[numArgs][1] == 'i') {
        if (numArgs + 1 >= argc || argv[numArgs + 1][0] == '-') {
          return false;
        }

        parsed.insert({"-i", std::string(argv[numArgs + 1])});
        numArgs++;
      } else if (argv[numArgs][1] == 'o') {
        if (numArgs + 1 >= argc || argv[numArgs + 1][0] == '-') {
          return false;
        }

        parsed.insert({"-o", std::string(argv[numArgs + 1])});
        numArgs++;
      } else if (argv[numArgs][1] == 'f') {
        if (numArgs + 1 >= argc || argv[numArgs + 1][0] == '-') {
          return false;
        }

        parsed.insert({"-f", std::string(argv[numArgs + 1])});
        numArgs++;
      } else if (argv[numArgs][1] == 't') {
        if (numArgs + 1 >= argc || argv[numArgs + 1][0] == '-') {
          return false;
        }

        parsed.insert({"-t", std::string(argv[numArgs + 1])});
        numArgs++;
      } else if (argv[numArgs][1] == 'n') {
        if (numArgs + 1 >= argc || argv[numArgs + 1][0] == '-') {
          return false;
        }

        parsed.insert({"-n", std::string(argv[numArgs + 1])});
        numArgs++;
      } else if (argv[numArgs][1] == '1') {
        if (numArgs + 1 >= argc || argv[numArgs + 1][0] == '-') {
          return false;
        }

        parsed.insert({"-1", std::string(argv[numArgs + 1])});
        numArgs++;
      } else if (argv[numArgs][1] == '2') {
        if (numArgs + 1 >= argc || argv[numArgs + 1][0] == '-') {
          return false;
        }

        parsed.insert({"-2", std::string(argv[numArgs + 1])});
        numArgs++;
      } else if (argv[numArgs][1] == 's') {
        if (numArgs + 1 >= argc || argv[numArgs + 1][0] == '-') {
          return false;
        }

        parsed.insert({"-s", std::string(argv[numArgs + 1])});
        numArgs++;
      } else if (argv[numArgs][1] == 'd') {
        parsed.insert({"-d",""});
      } else {
        return false;
      }
    } else {
      return false;
    }
  }

  return true;
}
